import React from 'react';
import PropTypes from 'prop-types';
import styled from 'styled-components';
import { colorWhiteLilac } from '@tds/core-colours';
import FlexGrid from '@tds/core-flex-grid';
import DecorativeIcon from '@tds/core-decorative-icon';
import StandaloneIcon from '@tds/core-standalone-icon';
import Paragraph from '@tds/core-paragraph';
import Box from '@tds/core-box';
import { Reveal, Fade } from '@tds/shared-animation';
import { messaging } from '@tds/shared-styles';

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

var classCallCheck = _classCallCheck;

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

var createClass = _createClass;

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var _typeof_1 = createCommonjsModule(function (module) {
function _typeof2(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof2 = function _typeof2(obj) { return typeof obj; }; } else { _typeof2 = function _typeof2(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof2(obj); }

function _typeof(obj) {
  if (typeof Symbol === "function" && _typeof2(Symbol.iterator) === "symbol") {
    module.exports = _typeof = function _typeof(obj) {
      return _typeof2(obj);
    };
  } else {
    module.exports = _typeof = function _typeof(obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : _typeof2(obj);
    };
  }

  return _typeof(obj);
}

module.exports = _typeof;
});

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

var assertThisInitialized = _assertThisInitialized;

function _possibleConstructorReturn(self, call) {
  if (call && (_typeof_1(call) === "object" || typeof call === "function")) {
    return call;
  }

  return assertThisInitialized(self);
}

var possibleConstructorReturn = _possibleConstructorReturn;

var getPrototypeOf = createCommonjsModule(function (module) {
function _getPrototypeOf(o) {
  module.exports = _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

module.exports = _getPrototypeOf;
});

var setPrototypeOf = createCommonjsModule(function (module) {
function _setPrototypeOf(o, p) {
  module.exports = _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

module.exports = _setPrototypeOf;
});

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) setPrototypeOf(subClass, superClass);
}

var inherits = _inherits;

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

var defineProperty = _defineProperty;

var _extends_1 = createCommonjsModule(function (module) {
function _extends() {
  module.exports = _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

module.exports = _extends;
});

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

var objectWithoutPropertiesLoose = _objectWithoutPropertiesLoose;

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = objectWithoutPropertiesLoose(source, excluded);
  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

var objectWithoutProperties = _objectWithoutProperties;

var safeRest = (function (_ref) {
  var style = _ref.style,
      className = _ref.className,
      as = _ref.as,
      props = objectWithoutProperties(_ref, ["style", "className", "as"]);

  return props;
});

/* eslint-disable import/prefer-default-export */
var warn = function warn(componentName, message) {
  if (process.env.NODE_ENV === 'production') {
    return;
  }

  console.warn("[TDS] ".concat(componentName, ": ").concat(message)); // eslint-disable-line no-console
};

var StyledNotificationContainer = styled(function (_ref) {
  var variant = _ref.variant,
      rest = objectWithoutProperties(_ref, ["variant"]);

  return React.createElement(Box, rest);
})(function (_ref2) {
  var variant = _ref2.variant;
  return _extends_1({
    position: 'relative'
  }, {
    instructional: messaging.standard,
    success: messaging.success,
    error: messaging.error,
    branded: {
      backgroundColor: colorWhiteLilac
    }
  }[variant]);
});
var StyledMessageContainer = styled.div.withConfig({
  displayName: "Notification__StyledMessageContainer",
  componentId: "sc-2ooxvf-0"
})(function (_ref3) {
  var hasIcon = _ref3.hasIcon;
  return {
    width: hasIcon ? 'calc(100% - 2.5rem)' : '100%'
  };
});
var StyledDismissContainer = styled.div.withConfig({
  displayName: "Notification__StyledDismissContainer",
  componentId: "sc-2ooxvf-1"
})({
  position: 'relative'
});
var StyledDismissButtonWrapper = styled.div.withConfig({
  displayName: "Notification__StyledDismissButtonWrapper",
  componentId: "sc-2ooxvf-2"
})({
  position: 'absolute',
  top: '-0.2rem',
  right: 0
});
var iconByVariant = {
  success: {
    symbol: 'checkmark',
    color: 'primary'
  },
  error: {
    symbol: 'exclamationPointCircle',
    color: 'error'
  }
};

var isImportant = function isImportant(variant) {
  return variant === 'success' || variant === 'error';
};

var renderIcon = function renderIcon(icon) {
  return React.createElement(DecorativeIcon, {
    symbol: icon.symbol,
    variant: icon.color
  });
};
/**
 * A banner that highlights important messages.
 *
 * @version ./package.json
 */


var Notification =
/*#__PURE__*/
function (_React$Component) {
  inherits(Notification, _React$Component);

  function Notification() {
    var _getPrototypeOf2;

    var _this;

    classCallCheck(this, Notification);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = possibleConstructorReturn(this, (_getPrototypeOf2 = getPrototypeOf(Notification)).call.apply(_getPrototypeOf2, [this].concat(args)));

    defineProperty(assertThisInitialized(_this), "state", {
      dismissed: false,
      contentWrapperHeight: undefined
    });

    defineProperty(assertThisInitialized(_this), "adjustContentHeight", function () {
      if (_this.contentWrapper.offsetHeight !== _this.state.contentWrapperHeight) {
        _this.setState({
          contentWrapperHeight: _this.contentWrapper.offsetHeight
        });
      }
    });

    return _this;
  }

  createClass(Notification, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.dismissible) {
        this.adjustContentHeight();
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      if (this.props.dismissible) {
        this.adjustContentHeight();
      }
    }
  }, {
    key: "renderNotification",
    value: function renderNotification() {
      var _this2 = this;

      var _this$props = this.props,
          variant = _this$props.variant,
          dismissible = _this$props.dismissible,
          dismissibleA11yLabel = _this$props.dismissibleA11yLabel,
          children = _this$props.children,
          onExit = _this$props.onExit,
          onDismiss = _this$props.onDismiss,
          rest = objectWithoutProperties(_this$props, ["variant", "dismissible", "dismissibleA11yLabel", "children", "onExit", "onDismiss"]);

      return React.createElement(StyledNotificationContainer, _extends_1({}, safeRest(rest), {
        vertical: 3,
        variant: variant
      }), React.createElement(FlexGrid, null, React.createElement(FlexGrid.Row, null, React.createElement(FlexGrid.Col, null, React.createElement(FlexGrid, {
        gutter: false
      }, React.createElement(FlexGrid.Row, null, React.createElement(FlexGrid.Col, {
        xs: dismissible ? 11 : undefined
      }, React.createElement(Box, {
        inline: true,
        between: 3
      }, isImportant(variant) ? renderIcon(iconByVariant[variant]) : undefined, React.createElement(StyledMessageContainer, {
        hasIcon: isImportant(variant)
      }, React.createElement(Paragraph, null, children)))), dismissible && React.createElement(FlexGrid.Col, null, React.createElement(StyledDismissContainer, null, React.createElement(StyledDismissButtonWrapper, null, React.createElement(StandaloneIcon, {
        symbol: "times",
        size: 24,
        a11yText: dismissibleA11yLabel,
        variant: variant === 'instructional' ? 'secondary' : undefined,
        onClick: function onClick() {
          _this2.setState(function () {
            return {
              dismissed: true
            };
          });

          if (onDismiss) {
            onDismiss();
          }
        }
      }))))))))));
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$props2 = this.props,
          dismissible = _this$props2.dismissible,
          dismissibleA11yLabel = _this$props2.dismissibleA11yLabel,
          onExit = _this$props2.onExit,
          onDismiss = _this$props2.onDismiss;
      var dismissibleHasA11yLabel = dismissible && dismissibleA11yLabel;

      if ((dismissible || dismissibleA11yLabel) && !dismissibleHasA11yLabel) {
        warn('Notification', 'The props `dismissible` and `dismissibleA11yLabel` must be used together.');
      }

      if (onExit && !dismissibleHasA11yLabel) {
        warn('Notification', 'The prop `onExit` must be used together with `dismissible` and `dismissibleA11yLabel`.');
      }

      if (onDismiss && !dismissibleHasA11yLabel) {
        warn('Notification', 'The prop `onDismiss` must be used together with `dismissible` and `dismissibleA11yLabel`.');
      }

      if (this.props.dismissible) {
        return React.createElement(Reveal, {
          timeout: 400,
          in: !this.state.dismissed,
          height: this.state.contentWrapperHeight || 0
        }, function () {
          return React.createElement(Fade, {
            unmountOnExit: true,
            timeout: 500,
            in: !_this3.state.dismissed,
            onExited: _this3.props.onExit
          }, function () {
            return React.createElement("div", {
              ref: function ref(c) {
                _this3.contentWrapper = c;
              }
            }, _this3.renderNotification());
          });
        });
      }

      return this.renderNotification();
    }
  }]);

  return Notification;
}(React.Component);

Notification.propTypes = {
  /**
   * The appearance.
   */
  variant: PropTypes.oneOf(['instructional', 'branded', 'success', 'error']),

  /**
   * Whether or not to allow the Notificiation to be dismissed.
   *
   * @since 1.2.0
   */
  dismissible: PropTypes.bool,

  /**
   * A label for assistive technology
   *
   * @since 1.2.0
   */
  dismissibleA11yLabel: PropTypes.string,

  /**
   * A callback function to be run on click of the dismissible icon.
   * Requires `dismissible={true}`
   *
   * @since 1.3.0
   */
  onDismiss: PropTypes.func,

  /**
   * A callback function to be run when the Notification has fully played its exit animation
   * Requires `dismissible={true}`
   *
   * @since 1.3.0
   */
  onExit: PropTypes.func,

  /**
   * The message. Can be raw text or text components.
   */
  children: PropTypes.node.isRequired
};
Notification.defaultProps = {
  variant: 'instructional',
  dismissible: false,
  dismissibleA11yLabel: undefined,
  onDismiss: undefined,
  onExit: undefined
};

export default Notification;
